#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>

#define r 1000.0  /*RANGO SUPERIOR DE LOS DATOS A GENERAR*/
#define x 10     /*VECES QUE SE ORDENARN LOS N DATOS*/
#define it 10  /*NMERO DE CANTIDAD DE DATOS A ORDENAR*/
		
int a[10000],c[10000];
float t1[x],t2[x],pi[x],pb[x];
struct timeval ti,tf;
FILE *archivo1,*archivo2;      /*VARIABLES PARA LOS ARCHIVOS QUE ALMACENARAN LOS TIEMPOS */
 			       /*DE CADA ALGORITMO*/


				/** FUNCIN QUE ORDENA UTILIZANDO EL MTODO DE LA BURBUJA*/
BubbleSort(int a[], int m)
{
	int j,i,key;
	gettimeofday(&ti,NULL);
	for(i=1;i<m;i++){
		for(j=m-1;j>i-1;j--){
			if(a[j-1]>a[j]){
				key=a[j-1];
				a[j-1]=a[j];
				a[j]=key;
			}
		}
	}
	gettimeofday(&tf,NULL);
}


				/**FUNCIN QUE ORDENA UTILIZANDO EL MTODO DE INSERCIN*/
InsertionSort(int a[], int m)
{

	int j, i, key;

	gettimeofday(&ti,NULL);			

	for (j=1;  j<m; j++) {
        	 key = a[j];
	         i = j-1;
         	while( i>=0  && a[i] > key ){
		        a[i+1] = a[i];
        		i --;
         	}
	         a[i+1]=key;
         }

	gettimeofday(&tf,NULL);
}



			/****ESTRUCTURA PRINCIPAL*****/							
main()

{
	int i,y,h;
	int n;

	archivo1=fopen("bubble","w");   		/* CREACIN DE ARCHIVOS PARA ALMACENAR LOS TIEMPOS*/
	archivo2=fopen("insertion","w");
	for(h=0;h<it;h++){
		n=(1000*(h+1)*(h+1))/it;
		printf(" Ordenando %d datos ...Espere \n",n);
        	for(y=0;y<x;y++){
			for(i=0;i<n;i++){               /*CREACIN ALEATORIA DE LOS DATOS A ORDENAR*/
				srand(i);
				a[i]=1+(int)(r*rand()/(RAND_MAX+1.0));
				printf("%d\n",a[i]);
				c[i]=a[i];
			}
			BubbleSort(a,n);
	                t1[y] = tf.tv_sec - ti.tv_sec + (tf.tv_usec - ti.tv_usec)/1.0e6;  /*TIEMPO QUE DEMORA EL MTODO BURBUJA*/
	                InsertionSort(c,n);
			t2[y] = tf.tv_sec - ti.tv_sec + (tf.tv_usec - ti.tv_usec)/1.0e6;  /*TIEMPO QUE DEMORA EL MTODO INSERCIN*/
		}
		pb[h]=0;
		pi[h]=0;
		printf("Hecho.\n");
		for(i=0;i<x;i++){                     /*CLCULO DEL TIEMPO PROMEDIO*/
			pb[h]=pb[h]+t1[i];
			pi[h]=pi[h]+t2[i];
		}
		pb[h]=pb[h]/x;
		pi[h]=pi[h]/x;
                fprintf(archivo1,"\t%d\t%f\n",n,pb[h]);   /*INGRESO DE DATOS A LOS ARCHIVOS A GRAFICAR*/
                fprintf(archivo2,"\t%d\t%f\n",n,pi[h]);
	}
        fclose(archivo1);
	fclose(archivo2);
	printf("\nMostrando el grfico:\n");
	printf("Presione ENTER para terminar\n");
	system("gnuplot graph.gnu");         /*PLOTEO DE LOS ARCHIVOS CON LOS DATOS*/
}

